use std::sync::Arc;

use crate::enums::ProtocolVersion;

use super::command_base::{CommandDeserializer, DeserializedCommand};

pub const DESERIALIZE_INIT_COMPLETE_RAW_NAME: &str = "InCm";

#[derive(Debug)]
pub struct InitComplete {}

impl DeserializedCommand for InitComplete {
    fn raw_name(&self) -> &'static str {
        DESERIALIZE_INIT_COMPLETE_RAW_NAME
    }

    fn apply_to_state(&self, _state: &mut crate::state::AtemState) {}
}

#[derive(Default)]
pub struct InitCompleteDeserializer {}

impl CommandDeserializer for InitCompleteDeserializer {
    fn deserialize(
        &self,
        _buffer: &[u8],
        version: &ProtocolVersion,
    ) -> Arc<dyn DeserializedCommand> {
        Arc::new(InitComplete {})
    }
}
