#[derive(Clone, PartialEq, Getters, new, Default)]
pub struct MacroPlayerState {
    pub is_running: bool,
    pub is_waiting: bool,
    pub is_loop: bool,
    pub macro_index: u64,
}

#[derive(Clone, PartialEq, Getters, new, Default)]
pub struct MacroRecorderState {
    pub is_recording: bool,
    pub macro_index: u64,
}

#[derive(Clone, PartialEq, Getters, new)]
pub struct MacroPropertiesState {
    is_used: bool,
    has_unsupported_ops: bool,
    pub name: String,
    pub description: String,
}

#[derive(Clone, PartialEq, Getters, new, Default)]
pub struct MacroState {
    pub macro_player: MacroPlayerState,
    pub macro_recorder: MacroRecorderState,
    macro_properties: Vec<MacroPropertiesState>,
}
