use crate::enums::{StreamingError, StreamingStatus};

use super::common::Timecode;

#[derive(Clone, PartialEq, Getters)]
pub struct StreamingState {
    pub status: Option<StreamingStateStatus>,
    pub stats: Option<StreamingStateStats>,
    pub service: StreamingServiceProperties,

    pub duration: Option<Timecode>,
}

#[derive(Clone, PartialEq, Getters, new)]
pub struct StreamingStateStatus {
    state: StreamingStatus,
    error: StreamingError,
}

#[derive(Clone, PartialEq, Getters, new)]
pub struct StreamingStateStats {
    cache_used: u64,
    encoding_bitrate: u64,
}

#[derive(Clone, PartialEq)]
pub struct StreamingServiceProperties {
    pub service_name: String,
    pub url: String,
    pub key: String,

    bitrates: (u64, u64),
}
