use crate::enums::{TransitionSelection, TransitionStyle};

use super::{
    settings::MultiViewer,
    video::{MixEffect, TransitionPosition, TransitionProperties, TransitionSettings},
    AtemState,
};

pub fn create() -> AtemState {
    AtemState::default()
}

pub fn get_mix_effect(state: &mut AtemState, index: usize) -> &mut MixEffect {
    // TODO: Use of index here is terrible and dangerous

    if state.video.mix_effects().get(index).is_none() {
        let mix_effect = MixEffect::new(
            index,
            0,
            0,
            false,
            None,
            TransitionPosition::new(false, 0.0, 0.0),
            TransitionProperties::new(
                TransitionStyle::MIX,
                vec![TransitionSelection::Background],
                TransitionStyle::MIX,
                vec![TransitionSelection::Background],
            ),
            TransitionSettings::new(None, None, None, None, None),
            vec![],
        );
        state.video.mix_effects_mut()[index] = mix_effect.clone();
    };

    &mut state.video.mix_effects_mut()[index]
}

pub fn get_multi_viewer(state: &mut AtemState, index: usize) -> Option<&MultiViewer> {
    state.settings.multi_viewers().get(index)
}
